#include<iostream>
#include<TSCtimestamp.h>
#include<clocktime.h>
#include<string.h>

int main(int argc,char **argv)
{
    struct timespec checkinterval;
    checkinterval.tv_sec = 0;
    checkinterval.tv_nsec = 25000000;
    
    clockid_t clk_id=CLOCK_MONOTONIC;
    if(argc>1)
    {
	char **arg = argv+1;
	if(strcmp(*arg,"-M")==0)
	{
	    clk_id=CLOCK_MONOTONIC;
	    std::clog << "CLOCK_MONOTONIC" << std::endl;
	}
	else if(strcmp(*arg,"-R")==0)
	{
	    clk_id=CLOCK_REALTIME;
	    std::clog << "CLOCK_REALTIME" << std::endl;
	}
    }


    time64_t firstmono = getclocktime(clk_id);
    TSCTimestamp_t firsttsc = getTSCtimestamp();
    time64_t lastmono = firstmono;
    TSCTimestamp_t lasttsc = firsttsc;

    for(int i=0;i<500;i++)
    {
	nanosleep(&checkinterval,0);
	time64_t currentmono = getclocktime(clk_id);
	TSCTimestamp_t currenttsc = getTSCtimestamp();
	time64_t monorel = currentmono-firstmono;
        TSCTimestamp_t tscrel = currenttsc-firsttsc;
	uint64_t diffmono=currentmono-lastmono;
	uint64_t difftsc =currenttsc -lasttsc;
	std::cout  << i << '\t'
		   << monorel << '\t' << tscrel
		   << '\t' << diffmono << '\t' << difftsc
		   << '\t' << (double)(difftsc)/double(diffmono)
		   << std::endl;
	
	lastmono=currentmono;
	lasttsc =currenttsc;
    }
}
